## This folder contains python and yaml files for multiple RasPI's GPIO usage talking to MQTT on HASS

* Built on Arch Linux ARM - armv7l
* Python 3 + libraries
* You can use as many RPI's you require and their GPIO's with this setup
* Use at your own risk. Presumes user understands YAML and python
* interval in the yml file is just that, in second, how often to collect data, just like splunk interval
* No, I am not going to help you, if you download this stuff you have decided you know what your doing and don't require any help - written by a random crazy aussie bloke living the dream and solving own problems
* I recently built some python to perform a number of operations from a variety of devices but use YAML for device information
* Looks for yaml files in /etc/iot/ folder - inspect the script
* the variable fred means (freaking.. ridiculous electronic devices)
* python scripts publish the configuration (auto discovery) data for devices
* i built this stuff purely by reading online manuals and community stuff, it might not be correct ways to do things as the original authors of HASS intended, i just went with what worked for me first.

## Action items

* [ ] To use you need to install the python libraries required by the scripts
* [ ] eg. MQTT server on HASS with listener 1883 <eth0 - ip address> in mosquitto.conf

## Files and notes

1-wire-publish-mqtt.service - service unit file for read_pub_temp.py - place in /etc/systemd/system & enable service

1w_temp_sensors.yml - uses folders and unique 1 wire id. use w1-devices.py to find ID - place in /etc/iot/

binary_sensors.yml - used by gpio_pub_state.py place in /etc/iot/ folder (sets up sensors or INPUTS on the GPIO)

binary_switches.yml - used by gpio_pub_setstate.py plice in /etc/iot/ folder (sets up switching devices or OUTPUTS on the GPIO)

dht11_pub_data.py - python script to read DHT11 1w dual temp + humidity and publish to MQTT uses dht11.yml - place in /usr/local/bin folder

dht11-publish-mqtt.service - service unit file for above script - place in /etc/systemd/system & enable service

dht11.yml - setup file for the dht11-pubdata.py script, place in /etc/iot

gpio_pub_setstate.py - uses binary_switches.yml for setup, publishes the states and sets the GPIO state accordindly to published MQTT topic (or subscribed to), also sends discovery data. place in /usr/local/bin folder

gpio_pub_state.py - uses binary_sensors.yml for setup, reads GPIO state and publishes data to topic,  also sends discovery data. place in /usr/local/bin folder

gpio-publish-mqtt.service - service unit file for gpio_pub_state.py - place in /etc/systemd/system & enable service

gpio-subscribe-mqtt-setstate.service - service unit file for gpio_pub_setstate.py - place in /etc/systemd/system & enable service

read_pub_temp.py - reads file data of 1w devices, this is setup for digital temperature - can be adapted for other 1 wire - see 1-wire-publish-mqtt.service

README.md - this file

w1-devices.py - get ID of 1 wire devices