#!/usr/bin/env python3
import paho.mqtt.client as paho
import time
import json
import sys
import bios
import Adafruit_DHT
import socket

def on_publish(client, userdata, mid):
#    print("data published "+str(mid))
    pass 

#read yaml file
mqtt_pub = bios.read('/etc/iot/dht11.yml')

#setup mqtt
client = paho.Client("DHT11_Publish")
client.on_publish = on_publish
client.username_pw_set(mqtt_pub["mqtt"]["username"], mqtt_pub["mqtt"]["passwd"])
client.connect(mqtt_pub["mqtt"]["server"], mqtt_pub["mqtt"]["port"])
client.loop_start()

# grab hostname short
shorthost = socket.gethostname().split('.', 1)[0]

print("Reading Device/s Temperature + Humidity & Publishing to topic/s")
for auto_device_item, auto_temp_topic_item, auto_temp_name_item, auto_humid_topic_item, auto_humid_name_item \
in zip(mqtt_pub["dht11_gpio_port"], mqtt_pub["temperature_topic"],  mqtt_pub["temperature_name"], mqtt_pub["humidity_topic"], mqtt_pub["humidity_name"]):
    new_temp_topic_item = auto_temp_topic_item+"/config"
    new_humid_topic_item = auto_humid_topic_item+"/config"
    fred1 = {"state_topic": auto_temp_topic_item, "json_attributes_topic": auto_temp_topic_item, "unit_of_measurement": '°C', "value_template": \
"{{ value_json.temperature}}", "unique_id": "DHT11_Temperature_GPIO_Port_"+str(auto_device_item), "device_class": "temperature", "device": \
{ "identifiers": [ "RPi GPIO DHT11 Temp Sensor" ], "name": "Temperature Sensor on host - "+str(shorthost)+" GPIO port "+str(auto_device_item), \
"model": "DHT11 Temperature sensor from RPi via MQTT", "manufacturer": "Raspberry Pi Foundation" }}
    fred2 = {"state_topic": auto_humid_topic_item, "json_attributes_topic": auto_humid_topic_item, "unit_of_measurement": '%', "value_template": \
"{{ value_json.humidity}}", "unique_id": "DHT11_Humidity_GPIO_Port_"+str(auto_device_item), "name": auto_humid_name_item, "device_class": "humidity", "device": \
{ "identifiers": [ "RPi GPIO DHT11 Humidity Sensor" ], "name": "Humidity Sensor on host - "+str(shorthost)+" GPIO port "+str(auto_device_item), \
"model": "DHT11 Humidity sensor from RPi via MQTT", "manufacturer": "Raspberry Pi Foundation" }} 
    (rc, mid) = client.publish(new_temp_topic_item, json.dumps(fred1), qos=1)
    if rc > 0:
        raise Exception(rc)
    (rc, mid) = client.publish(new_humid_topic_item, json.dumps(fred2), qos=1)
    if rc > 0:
        raise Exception(rc)

while True:
    try:
         for device_item, temp_topic_item, humid_topic_item in zip(mqtt_pub["dht11_gpio_port"], mqtt_pub["temperature_topic"], mqtt_pub["humidity_topic"]):
        # the 11 is the device type DHT11 following
             humidity, temperature = Adafruit_DHT.read_retry(11, device_item)
             print(temperature, humidity)
#             print ('Temp: {0:0.1f} C  Humidity: {1:0.1f} %'.format(temperature, humidity))
             y = { "temperature": temperature }
             x = { "humidity": humidity}
#             print(device_item,x,y,rc,mid,temp_topic_item)
#             time.sleep(1)
             if temperature != None:
                 (rc, mid) = client.publish(temp_topic_item, json.dumps(y),qos=1 )
                 if rc > 0:
                     raise Exception(rc)
             if humidity != None:
                 (rc, mid) = client.publish(humid_topic_item, json.dumps(x), qos=1)
                 if rc > 0:
                     raise Exception(rc)
         time.sleep(mqtt_pub["interval"])

#         for auto_device_item, auto_temp_topic_item, auto_temp_name_item, auto_humid_topic_item, auto_humid_name_item in zip(mqtt_pub["dht11_gpio_port"],\
#mqtt_pub["temperature_topic"],  mqtt_pub["temperature_name"], mqtt_pub["humidity_topic"], mqtt_pub["humidity_name"]):
         new_temp_topic_item = auto_temp_topic_item+"/config"
         new_humid_topic_item = auto_humid_topic_item+"/config"
#         print(new_temp_topic_item, new_humid_topic_item)
         fred1 = {"state_topic": auto_temp_topic_item, "json_attributes_topic": auto_temp_topic_item, "unit_of_measurement": '°C', "value_template": \
"{{ value_json.temperature}}", "unique_id": "DHT11_Temperature_GPIO_Port_"+str(auto_device_item), "device_class": "temperature", "device": \
{ "identifiers": [ "RPi GPIO DHT11 Temp Sensor" ], "name": "Temperature Sensor on host - "+str(shorthost)+" GPIO port "+str(auto_device_item), \
"model": "DHT11 Temperature sensor from RPi via MQTT", "manufacturer": "Raspberry Pi Foundation" }}
         fred2 = {"state_topic": auto_humid_topic_item, "json_attributes_topic": auto_humid_topic_item, "unit_of_measurement": '%', "value_template": \
"{{ value_json.humidity}}", "unique_id": "DHT11_Humidity_GPIO_Port_"+str(auto_device_item), "name": auto_humid_name_item, "device_class": "humidity", "device": \
{ "identifiers": [ "RPi GPIO DHT11 Humidity Sensor" ], "name": "Humidity Sensor on host - "+str(shorthost)+" GPIO port "+str(auto_device_item), \
"model": "DHT11 Humidity sensor from RPi via MQTT", "manufacturer": "Raspberry Pi Foundation" }}
         (rc, mid) = client.publish(new_temp_topic_item, json.dumps(fred1), qos=1)
         if rc > 0:
             raise Exception(rc)
         (rc, mid) = client.publish(new_humid_topic_item, json.dumps(fred2), qos=1)
         if rc > 0:
             raise Exception(rc)
        
    except Exception as e:
        print("There is a problem! The exception or return code is: ",e," - consult manuals for description")
        client.disconnect()
        sys.exit(rc)
