#!/usr/bin/env python3
import RPi.GPIO as GPIO
import paho.mqtt.client as paho
import time
import json
import sys
import bios
import socket

def on_publish(client, userdata, mid):
#    print("data published "+str(mid))
    pass 

mqtt_pub = bios.read('/etc/iot/binary_sensors.yml')

client = paho.Client("RPi Binary Sensors")
client.on_publish = on_publish
client.username_pw_set(mqtt_pub["mqtt"]["username"], mqtt_pub["mqtt"]["passwd"])
client.connect(mqtt_pub["mqtt"]["server"], mqtt_pub["mqtt"]["port"])
client.loop_start()

# Raspberry GPIO Configuration
GPIO.setmode(GPIO.BCM)

# grab hostname short
shorthost = socket.gethostname().split('.', 1)[0]

print("Reading RPi GPIO port states & Publishing to topic/s")
for auto_gpio_port_item, auto_topic_item, auto_name_item, auto_class_item \
in zip(mqtt_pub["gpio_port"], mqtt_pub["gpio_port_2_topic"], mqtt_pub["gpio_sensor_name"], mqtt_pub["gpio_sensor_class"]):
    new_topic_item = auto_topic_item+"/config"
    fred = {"state_topic": auto_topic_item+"/state", "name": auto_name_item, "device_class": auto_class_item, \
    "unique_id": "rpi_gpio_"+str(auto_gpio_port_item), "device": { "identifiers": [ "RPi GPIO Sensor "+str(auto_gpio_port_item) ], \
    "name": "GPIO Circuit Sensor on port "+str(auto_gpio_port_item)+" on host - "+str(shorthost)+" class:"+auto_class_item, \
    "model": "GPIO circuit sensor on port "+str(auto_gpio_port_item)+" on host - "+str(shorthost), "manufacturer": "Raspberry Pi Foundation", \
    "via_device": "Remote Raspi GPIO via MQTT" } }
    # Raspberry GPIO Configuration
    GPIO.setup(auto_gpio_port_item, GPIO.IN, pull_up_down=GPIO.PUD_UP)
    (rc, mid) = client.publish(new_topic_item, json.dumps(fred), qos=mqtt_pub["qos"])
    if rc > 0:
        raise Exception(rc)

while True:
  try:
    for auto_gpio_port_item, auto_topic_item, auto_name_item, auto_class_item \
    in zip(mqtt_pub["gpio_port"], mqtt_pub["gpio_port_2_topic"], mqtt_pub["gpio_sensor_name"], mqtt_pub["gpio_sensor_class"]):
        state_topic_item = auto_topic_item+"/state"
        if GPIO.input(auto_gpio_port_item)==True:
            (rc, mid) = client.publish(state_topic_item, "ON", qos=mqtt_pub["qos"], retain=True)
        if GPIO.input(auto_gpio_port_item)==False:
            (rc, mid) = client.publish(state_topic_item, "OFF", qos=mqtt_pub["qos"], retain=True)
    if rc > 0:
        raise Exception(rc)
    time.sleep(mqtt_pub["interval"])
    for auto_gpio_port_item, auto_topic_item, auto_name_item, auto_class_item \
    in zip(mqtt_pub["gpio_port"], mqtt_pub["gpio_port_2_topic"], mqtt_pub["gpio_sensor_name"], mqtt_pub["gpio_sensor_class"]):
        new_topic_item = auto_topic_item+"/config"
        fred = {"state_topic": auto_topic_item+"/state", "name": auto_name_item, "device_class": auto_class_item, \
        "unique_id": "rpi_gpio_"+str(auto_gpio_port_item), "device": { "identifiers": [ "RPi GPIO Sensor "+str(auto_gpio_port_item) ], \
        "name": "GPIO Circuit Sensor on port "+str(auto_gpio_port_item)+" on host - "+str(shorthost)+" class:"+auto_class_item, \
        "model": "GPIO circuit sensor on port "+str(auto_gpio_port_item)+" on host - "+str(shorthost), "manufacturer": "Raspberry Pi Foundation", \
        "via_device": "Remote Raspi GPIO via MQTT" } }
        (rc, mid) = client.publish(new_topic_item, json.dumps(fred), qos=mqtt_pub["qos"])
        if rc > 0:
            raise Exception(rc)

  except Exception as e:
    print("There is a problem! The exception or return code is: ",e," - consult manuals for description")
    client.disconnect()
    sys.exit(rc)

GPIO.cleanup(gpiopin)
client.disconnect()